Index: src/sas/sasgui/guiframe/gui_manager.py
===================================================================
--- src/sas/sasgui/guiframe/gui_manager.py	(revision 9220e89c31ca5156d9c3a40634b4257084d139a2)
+++ src/sas/sasgui/guiframe/gui_manager.py	(revision 9220e89c31ca5156d9c3a40634b4257084d139a2)
@@ -13,6 +13,4 @@
 
 
-import wx
-import wx.aui
 import os
 import sys
@@ -25,4 +23,8 @@
 import urllib
 import json
+import copy
+
+import wx
+import wx.aui
 
 from matplotlib import _pylab_helpers
@@ -275,5 +277,5 @@
         return client size tuple
         """
-        width, height = self.GetClientSizeTuple()
+        width, height = self.GetClientSize()
         height -= 45
         # Adjust toolbar height
@@ -350,9 +352,8 @@
         try:
             self.read_batch_tofile(file_name=path)
-        except:
+        except Exception as exc:
             msg = "Error occurred when reading the file; %s\n" % path
-            msg += "%s\n" % sys.exc_value
-            wx.PostEvent(self, StatusEvent(status=msg,
-                                           info="error"))
+            msg += "%s\n" % exc
+            wx.PostEvent(self, StatusEvent(status=msg, info="error"))
 
     def read_batch_tofile(self, file_name):
@@ -694,8 +695,8 @@
         try:
             self.load_from_cmd(self._input_file)
-        except:
+        except Exception as exc:
             msg = "%s Cannot load file %s\n" % (str(APPLICATION_NAME),
                                                 str(self._input_file))
-            msg += str(sys.exc_value) + '\n'
+            msg += str(exc) + '\n'
             logger.error(msg)
         if self._data_panel is not None and len(self.plugins) > 0:
@@ -786,7 +787,7 @@
                 self._data_plugin = data_loader.Plugin()
                 plugins.append(self._data_plugin)
-            except:
+            except Exception as exc:
                 msg = "ViewerFrame._get_local_plugins:"
-                msg += "cannot import dataloader plugin.\n %s" % sys.exc_value
+                msg += "cannot import dataloader plugin.\n %s" % exc
                 logger.error(msg)
         if style2 == GUIFRAME.PLOTTING_ON:
@@ -796,7 +797,7 @@
                 self._plotting_plugin = plotting.Plugin()
                 plugins.append(self._plotting_plugin)
-            except:
+            except Exception as exc:
                 msg = "ViewerFrame._get_local_plugins:"
-                msg += "cannot import plotting plugin.\n %s" % sys.exc_value
+                msg += "cannot import plotting plugin.\n %s" % exc
                 logger.error(msg)
 
@@ -845,18 +846,18 @@
                                 msg = "Found plug-in: %s" % module.PLUGIN_ID
                                 logger.info(msg)
-                            except:
+                            except Exception as exc:
                                 msg = "Error accessing PluginPanel"
-                                msg += " in %s\n  %s" % (name, sys.exc_value)
+                                msg += " in %s\n  %s" % (name, exc)
                                 config.printEVT(msg)
-                    except:
-                        msg = "ViewerFrame._find_plugins: %s" % sys.exc_value
+                    except Exception as exc:
+                        msg = "ViewerFrame._find_plugins: %s" % exc
                         logger.error(msg)
                     finally:
                         if file is not None:
                             file.close()
-        except:
+        except Exception as exc:
             # Should raise and catch at a higher level and
             # display error on status bar
-            logger.error(sys.exc_value)
+            logger.error(exc)
 
         return plugins
@@ -1588,5 +1589,5 @@
         """
         # This CallAfter fixes many crashes on MAC.
-        wx.CallAfter(self.sb.set_status, evt)
+        wx.CallAfter(self.sb.set_status, evt.Clone())
 
     def on_view(self, evt):
@@ -1632,5 +1633,5 @@
         ID = str(uid)
         config.printEVT("delete_panel: %s" % ID)
-        if ID in self.panels.keys():
+        if ID in self.panels:
             self.panel_on_focus = None
             panel = self.panels[ID]
@@ -1644,7 +1645,7 @@
 
             # delete uid number not str(uid)
-            if ID in self.plot_panels.keys():
+            if ID in self.plot_panels:
                 del self.plot_panels[ID]
-            if ID in self.panels.keys():
+            if ID in self.panels:
                 del self.panels[ID]
         else:
@@ -1680,7 +1681,7 @@
                     try:
                         reader.read(path)
-                    except:
+                    except Exception as exc:
                         msg = "DataLoader Error: Encounted Non-ASCII character"
-                        msg += "\n(%s)" % sys.exc_value
+                        msg += "\n(%s)" % exc
                         wx.PostEvent(self, StatusEvent(status=msg,
                                                        info="error",
@@ -1763,8 +1764,8 @@
 
             self.add_data(data_list=output)
-        except:
+        except Exception as exc:
             error_message = "Error while loading"
             error_message += " Data from cmd:\n %s\n" % str(path)
-            error_message += str(sys.exc_value) + "\n"
+            error_message += str(exc) + "\n"
             logger.error(error_message)
 
@@ -1784,8 +1785,8 @@
             else:
                 return
-        except:
+        except Exception as exc:
             error_message = "Error while loading"
             error_message += " Data folder from cmd:\n %s\n" % str(path)
-            error_message += str(sys.exc_value) + "\n"
+            error_message += str(exc) + "\n"
             logger.error(error_message)
 
@@ -1854,6 +1855,6 @@
             self._data_panel.selection_cbox.SetValue('Select all Data')
             self._data_panel._on_selection_type(None)
-            for _, theory_dict in self._data_panel.list_cb_theory.iteritems():
-                for key, value in theory_dict.iteritems():
+            for _, theory_dict in self._data_panel.list_cb_theory.items():
+                for key, value in theory_dict.items():
                     item, _, _ = value
                     item.Check(True)
@@ -1963,5 +1964,5 @@
             # case of a panel with multi-pages
             if hasattr(panel, "opened_pages"):
-                for _, page in panel.opened_pages.iteritems():
+                for _, page in panel.opened_pages.items():
                     data = page.get_data()
                     # state must be cloned
@@ -2085,5 +2086,5 @@
                 msg += " Please try again later."
                 self.SetStatusText(msg)
-            elif cmp(version, config.__version__) > 0:
+            elif version > config.__version__:
                 msg = "Version %s is available! " % str(version)
                 if not standalone:
@@ -2101,7 +2102,7 @@
                     msg += " of %s" % str(config.__appname__)
                     self.SetStatusText(msg)
-        except:
+        except Exception as exc:
             msg = "guiframe: could not get latest application"
-            msg += " version number\n  %s" % sys.exc_value
+            msg += " version number\n  %s" % exc
             logger.error(msg)
             if not standalone:
@@ -2143,5 +2144,5 @@
         # S King, Sep 2018
 
-        from documentation_window import DocumentationWindow
+        from .documentation_window import DocumentationWindow
         _TreeLocation = "user/release.html"
         DocumentationWindow(self, -1, _TreeLocation, "",
@@ -2164,5 +2165,5 @@
         # S King, Sep 2018
 
-        from documentation_window import DocumentationWindow
+        from .documentation_window import DocumentationWindow
         _TreeLocation = "user/tutorial.html"
         DocumentationWindow(self, -1, _TreeLocation, "",
@@ -2179,5 +2180,5 @@
         # Running SasView "in-place" using run.py means the docs will be in a
         # different place than they would otherwise.
-        from documentation_window import DocumentationWindow
+        from .documentation_window import DocumentationWindow
         _TreeLocation = "user/user.html"
         DocumentationWindow(self, -1, _TreeLocation, "",
@@ -2227,5 +2228,5 @@
                 if (style == GUIFRAME.MANAGER_ON) \
                         and self.panels[item] == self._data_panel:
-                    if 'data_panel' in self.panels.keys():
+                    if 'data_panel' in self.panels:
                         frame = self.panels['data_panel'].get_frame()
                         if frame is None:
@@ -2279,5 +2280,5 @@
         # set data in the data panel
         if self._data_panel is not None:
-            data_state = self._data_manager.get_data_state(data_list.keys())
+            data_state = self._data_manager.get_data_state(list(data_list.keys()))
             self._data_panel.load_data_list(data_state)
         # if the data panel is shown wait for the user to press a button
@@ -2291,5 +2292,5 @@
         else:
             # automatically send that to the current perspective
-            self.set_data(data_id=data_list.keys())
+            self.set_data(data_id=list(data_list.keys()))
 
     def set_data(self, data_id, theory_id=None):
@@ -2299,5 +2300,5 @@
         list_data, _ = self._data_manager.get_by_id(data_id)
         if self._current_perspective is not None:
-            self._current_perspective.set_data(list_data.values())
+            self._current_perspective.set_data(list(list_data.values()))
 
         else:
@@ -2311,7 +2312,7 @@
         if self._current_perspective is not None:
             try:
-                self._current_perspective.set_theory(list_theory.values())
-            except:
-                msg = "Guiframe set_theory: \n" + str(sys.exc_value)
+                self._current_perspective.set_theory(list(list_theory.values()))
+            except Exception as exc:
+                msg = "Guiframe set_theory: \n" + str(exc)
                 logger.info(msg)
                 wx.PostEvent(self, StatusEvent(status=msg, info="error"))
@@ -2327,5 +2328,5 @@
         data_list, _ = self._data_manager.get_by_id(data_id)
         _, temp_list_theory = self._data_manager.get_by_id(theory_id)
-        total_plot_list = data_list.values()
+        total_plot_list = list(data_list.values())
         for item in temp_list_theory.values():
             theory_data, theory_state = item
@@ -2376,5 +2377,5 @@
         data_list, _ = self._data_manager.get_by_id(data_id)
         _, temp_list_theory = self._data_manager.get_by_id(theory_id)
-        total_plot_list = data_list.values()
+        total_plot_list = list(data_list.values())
         for item in temp_list_theory.values():
             theory_data, theory_state = item
@@ -2399,6 +2400,6 @@
                                             group_id=("res" + str(id)),
                                             action='remove'))
-        except:
-            logger.error(sys.exc_value)
+        except Exception as exc:
+            logger.error(exc)
 
     def save_data1d(self, data, fname):
@@ -2504,5 +2505,5 @@
             wx.PostEvent(self, StatusEvent(status=msg,
                                            info="error"))
-            raise ValueError, msg
+            raise ValueError(msg)
         # text = str(data)
         text = data.__str__()
@@ -2535,5 +2536,5 @@
                                                   dy_val,
                                                   dx_val)
-        from pdfview import TextFrame
+        from .pdfview import TextFrame
         frame = TextFrame(None, -1, "Data Info: %s" % data.name, text)
         # put icon
@@ -2627,5 +2628,5 @@
                 break
 
-        from pdfview import TextFrame
+        from .pdfview import TextFrame
         frame = TextFrame(None, -1, "Data Info: %s" % data.name, text)
         # put icon
@@ -2694,5 +2695,5 @@
         check = "Theory1D"
         is_theory = len(self.panel_on_focus.plots) <= 1 and \
-            self.panel_on_focus.plots.values()[0].__class__.__name__ == check
+            list(self.panel_on_focus.plots.values())[0].__class__.__name__ == check
 
         is_data2d = hasattr(new_plot, 'data')
@@ -3210,9 +3211,9 @@
             else:
                 self.frame.Show()
-        except:
+        except Exception as exc:
             if self.s_screen is not None:
                 self.s_screen.Close()
             msg = "Cannot display splash screen\n"
-            msg += str(sys.exc_value)
+            msg += str(exc)
             logger.error(msg)
             self.frame.Show()
@@ -3269,7 +3270,7 @@
                         if os.path.isfile(file_path):
                             os.remove(file_path)
-                except:
+                except Exception as exc:
                     logger.error("gui_manager.clean_plugin_models:\n  %s"
-                                  % sys.exc_value)
+                                 % exc)
 
     def set_manager(self, manager):
@@ -3364,4 +3365,9 @@
                               path=SPLASH_SCREEN_PATH):
         """Displays the splash screen.  It will exactly cover the main frame."""
+        try:
+            from wx.adv import SplashScreen, SPLASH_TIMEOUT, SPLASH_CENTRE_ON_SCREEN
+        except ImportError:
+            # CRUFT: wx 4 moved SplashScreen from wx to wx.adv
+            from wx import SplashScreen, SPLASH_TIMEOUT, SPLASH_CENTRE_ON_SCREEN
 
         # Prepare the picture.  On a 2GHz intel cpu, this takes about a second.
@@ -3380,13 +3386,13 @@
         # Note that on Linux, the timeout appears to occur immediately in which
         # case the splash screen disappears upon entering the event loop.
-        s_screen = wx.SplashScreen(bitmap=bm,
-                                   splashStyle=(wx.SPLASH_TIMEOUT |
-                                                wx.SPLASH_CENTRE_ON_SCREEN),
-                                   style=(wx.SIMPLE_BORDER |
-                                          wx.FRAME_NO_TASKBAR |
-                                          wx.FRAME_FLOAT_ON_PARENT),
-                                   milliseconds=SS_MAX_DISPLAY_TIME,
-                                   parent=parent,
-                                   id=wx.ID_ANY)
+        s_screen = SplashScreen(bitmap=bm,
+                                splashStyle=(SPLASH_TIMEOUT |
+                                             SPLASH_CENTRE_ON_SCREEN),
+                                style=(wx.SIMPLE_BORDER |
+                                       wx.FRAME_NO_TASKBAR |
+                                       wx.FRAME_FLOAT_ON_PARENT),
+                                milliseconds=SS_MAX_DISPLAY_TIME,
+                                parent=parent,
+                                id=wx.ID_ANY)
         from sas.sasgui.guiframe.gui_statusbar import SPageStatusbar
         statusBar = SPageStatusbar(s_screen)
Index: src/sas/sasgui/guiframe/gui_statusbar.py
===================================================================
--- src/sas/sasgui/guiframe/gui_statusbar.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/guiframe/gui_statusbar.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -86,5 +86,7 @@
                                                     wx.ART_TOOLBAR)
         self.msg_txt.Newline()
-        self.msg_txt.WriteBitmap(icon_bmp)
+        # wx 3 has WriteImage and WriteBitmap; not sure if there
+        # is any difference between them.  wx 4 has only WriteImage.
+        self.msg_txt.WriteImage(icon_bmp)
         self.msg_txt.BeginTextColour(color)
         self.msg_txt.WriteText("\t")
Index: src/sas/sasgui/guiframe/gui_style.py
===================================================================
--- src/sas/sasgui/guiframe/gui_style.py	(revision a1b8fee73528559155793dd74cda07d0c32e9d72)
+++ src/sas/sasgui/guiframe/gui_style.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -58,24 +58,30 @@
     DRAG_ID_PATH = os.path.join(PATH, 'drag_hand.png')
     RESET_ID_PATH = os.path.join(PATH, 'reset.png')
-    PREVIEW_ID_PATH = os.path.join(PATH, 'report.png')
+    REPORT_ID_PATH = os.path.join(PATH, 'report.png')
+    PREVIEW_ID_PATH = os.path.join(PATH, 'preview.png')
     PRINT_ID_PATH = os.path.join(PATH, 'printer.png')
     HIDE_ID_PATH = os.path.join(PATH, 'hide.png')
     
-  
-    SAVE_ICON = wx.Image(os.path.join(PATH, 'save.png'))
-    UNDO_ICON = wx.Image(os.path.join(PATH, 'undo.png'))
-    REDO_ICON = wx.Image(os.path.join(PATH, 'redo.png'))
-    COPY_ICON = wx.Image(os.path.join(PATH, 'copy.png'))
-    PASTE_ICON = wx.Image(os.path.join(PATH, 'paste.png'))
-    BOOKMARK_ICON = wx.Image(os.path.join(PATH, 'bookmark.png'))
-    ZOOM_IN_ICON = wx.Image(os.path.join(PATH, 'zoom_in.png'))
-    ZOOM_OUT_ICON = wx.Image(os.path.join(PATH, 'zoom_out.png'))
-    ZOOM_ICON = wx.Image(os.path.join(PATH, 'search_pan.png'))
-    DRAG_ICON = wx.Image(os.path.join(PATH, 'drag_hand.png'))
-    RESET_ICON = wx.Image(os.path.join(PATH, 'reset.png'))
-    REPORT_ICON = wx.Image(os.path.join(PATH, 'report.png'))
-    PREVIEW_ICON = wx.Image(os.path.join(PATH, 'preview.png'))
-    PRINT_ICON = wx.Image(os.path.join(PATH, 'printer.png'))
-    HIDE_ICON = wx.Image(os.path.join(PATH, 'hide.png'))
+    # Note: wx 4 requires that the app be defined before
+    # the images are loaded, so they can't be processed
+    # at module load time.  Instead, need to load icons
+    # when the app is created.
+    @classmethod
+    def load_icons(cls):
+        cls.SAVE_ICON = wx.Image(cls.SAVE_ICON_PATH)
+        cls.UNDO_ICON = wx.Image(cls.UNDO_ICON_PATH)
+        cls.REDO_ICON = wx.Image(cls.REDO_ICON_PATH)
+        cls.COPY_ICON = wx.Image(cls.COPY_ICON_PATH)
+        cls.PASTE_ICON = wx.Image(cls.PASTE_ICON_PATH)
+        cls.BOOKMARK_ICON = wx.Image(cls.BOOKMARK_ICON_PATH)
+        cls.ZOOM_IN_ICON = wx.Image(cls.ZOOM_IN_ID_PATH)
+        cls.ZOOM_OUT_ICON = wx.Image(cls.ZOOM_OUT_ID_PATH)
+        cls.ZOOM_ICON = wx.Image(cls.ZOOM_ID_PATH)
+        cls.DRAG_ICON = wx.Image(cls.DRAG_ID_PATH)
+        cls.RESET_ICON = wx.Image(cls.RESET_ID_PATH)
+        cls.REPORT_ICON = wx.Image(cls.REPORT_ID_PATH)
+        cls.PREVIEW_ICON = wx.Image(cls.PREVIEW_ID_PATH)
+        cls.PRINT_ICON = wx.Image(cls.PRINT_ID_PATH)
+        cls.HIDE_ICON = wx.Image(cls.HIDE_ID_PATH)
 
 if __name__ == "__main__":
Index: src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py	(revision 9c7e2b8361553f8e2f246d344c791c385f3b2254)
+++ src/sas/sasgui/guiframe/local_perspectives/data_loader/data_loader.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -70,5 +70,5 @@
                 cards.remove(item)
         wlist = '|'.join(cards)
-        style = wx.OPEN | wx.FD_MULTIPLE
+        style = wx.FD_OPEN | wx.FD_MULTIPLE
         dlg = wx.FileDialog(self.parent,
                             "Choose a file",
@@ -196,5 +196,5 @@
                                                       error_message)
                     if data_error:
-                        if basename in file_errors.keys():
+                        if basename in file_errors:
                             file_errors[basename] += [error_message]
                         else:
@@ -219,5 +219,5 @@
         if len(file_errors) > 0:
             error_message = ""
-            for filename, error_array in file_errors.iteritems():
+            for filename, error_array in file_errors.items():
                 error_message += "The following issues were found whilst "
                 error_message += "loading {}:\n".format(filename)
Index: src/sas/sasgui/guiframe/local_perspectives/data_loader/load_thread.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/data_loader/load_thread.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/local_perspectives/data_loader/load_thread.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -72,7 +72,7 @@
                 if self.updatefn is not None:
                     self.updatefn(output=output, message=message)
-            except:
+            except Exception as exc:
                 error_message = "Error while loading: %s\n" % str(path)
-                error_message += str(sys.exc_value) + "\n"
+                error_message += str(exc) + "\n"
                 self.updatefn(output=output, message=error_message)
 
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -7,13 +7,15 @@
 
 import math
+# from copy import deepcopy
+
 import wx
-# from copy import deepcopy
-# Debug printout
+
 from sas.sasgui.guiframe.events import NewPlotEvent
 from sas.sasgui.guiframe.events import StatusEvent
 from sas.sasgui.guiframe.events import SlicerParameterEvent
 from sas.sasgui.guiframe.events import EVT_SLICER_PARS
-from BaseInteractor import _BaseInteractor
 from sas.sasgui.guiframe.dataFitting import Data1D
+
+from .BaseInteractor import _BaseInteractor
 
 class AnnulusInteractor(_BaseInteractor):
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Arc.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -4,6 +4,7 @@
 import math
 
-from BaseInteractor import _BaseInteractor
 from sas.sasgui.guiframe.events import SlicerParameterEvent
+
+from .BaseInteractor import _BaseInteractor
 
 class ArcInteractor(_BaseInteractor):
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/AzimutSlicer.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/AzimutSlicer.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/AzimutSlicer.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -5,8 +5,11 @@
 #
 import math
+
 import wx
-from BaseInteractor import _BaseInteractor
+
 from sas.sasgui.guiframe.events import NewPlotEvent
 from sas.sasgui.guiframe.events import EVT_SLICER_PARS
+
+from .BaseInteractor import _BaseInteractor
 
 class SectorInteractor(_BaseInteractor):
@@ -29,5 +32,5 @@
 
         # Inner circle
-        from Arc import ArcInteractor
+        from .Arc import ArcInteractor
         self.inner_circle = ArcInteractor(self, self.base.subplot,
                                           zorder=zorder,
@@ -43,5 +46,5 @@
         self.outer_circle.qmax = self.qmax * 1.2
         # self.outer_circle.set_cursor(self.base.qmax/1.8, 0)
-        from Edge import RadiusInteractor
+        from .Edge import RadiusInteractor
         self.right_edge = RadiusInteractor(self, self.base.subplot,
                                            zorder=zorder + 1,
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Edge.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -1,4 +1,5 @@
 import math
-from BaseInteractor import _BaseInteractor
+
+from .BaseInteractor import _BaseInteractor
 
 
Index: src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py
===================================================================
--- src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 2469df7fc9ffa047115c5bffe589ed307b12c363)
+++ src/sas/sasgui/guiframe/local_perspectives/plotting/Plotter1D.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -11,9 +11,11 @@
 
 
-import wx
 import sys
 import math
+import logging
+
+import wx
 import numpy as np
-import logging
+
 from sas.sasgui.plottools.PlotPanel import PlotPanel
 from sas.sasgui.guiframe.events import StatusEvent
@@ -22,6 +24,7 @@
 from sas.sasgui.guiframe.panel_base import PanelBase
 from sas.sasgui.guiframe.gui_style import GUIFRAME_ICON
-from appearanceDialog import appearanceDialog
-from graphAppearance import graphAppearance
+
+from .appearanceDialog import appearanceDialog
+from .graphAppearance import graphAppearance
 
 logger = logging.getLogger(__name__)
@@ -36,5 +39,5 @@
 def find_key(dic, val):
     """return the key of dictionary dic given the value"""
-    return [k for k, v in dic.iteritems() if v == val][0]
+    return [k for k, v in dic.items() if v == val][0]
 
 class ModelPanel1D(PlotPanel, PanelBase):
@@ -220,5 +223,5 @@
         if hasattr(event, 'is_corfunc'):
             self.is_corfunc = event.is_corfunc
-        if event.id in self.plots.keys():
+        if event.id in self.plots:
             ctrl = event.ctrl
             self.cursor_id = event.id
@@ -243,6 +246,6 @@
                 if position is not None and not self.is_corfunc:
                     wx.PostEvent(self.parent, StatusEvent(status=position))
-            except:
-                logger.error(sys.exc_value)
+            except Exception as exc:
+                logger.error(exc)
             if not event.leftdown:
                 # text event
@@ -256,6 +259,6 @@
                     if is_moved:
                         self.canvas.draw()
-                except:
-                    logger.error(sys.exc_value)
+                except Exception as exc:
+                    logger.error(exc)
                 event.Skip()
                 return
@@ -410,6 +413,6 @@
             self.canvas.draw()
             self.q_ctrl[vl_ind].SetValue(str(pos_x))
-        except:
-            logger.error(sys.exc_value)
+        except Exception as exc:
+            logger.error(exc)
 
     def set_resizing(self, resizing=False):
@@ -431,5 +434,5 @@
             Remove data from plot
         """
-        if id in self.plots.keys():
+        if id in self.plots:
             data = self.plots[id]
             self.graph.delete(data)
@@ -437,7 +440,7 @@
             data_list, theory_list = data_manager.get_by_id(id_list=[id])
 
-            if id in data_list.keys():
+            if id in data_list:
                 data = data_list[id]
-            if id in theory_list.keys():
+            if id in theory_list:
                 data = theory_list[id]
 
@@ -457,5 +460,5 @@
         if data.__class__.__name__ == 'Data2D':
             return
-        plot_keys = self.plots.keys()
+        plot_keys = list(self.plots.keys())
         if data.id in plot_keys:
             # Recover panel prop.s
@@ -476,5 +479,5 @@
             try:
                 self._onEVT_FUNC_PROPERTY()
-            except Exception, exc:
+            except Exception as exc:
                 wx.PostEvent(self.parent,
                              StatusEvent(status="Plotting Error: %s" % str(exc), info="error"))
@@ -493,5 +496,5 @@
                     # MAC: forcing to plot 2D avg
                     self.canvas._onDrawIdle()
-            except Exception, exc:
+            except Exception as exc:
                 wx.PostEvent(self.parent, StatusEvent(status=\
                     "Plotting Error: %s" % str(exc), info="error"))
@@ -567,5 +570,5 @@
         self.set_selected_from_menu(menu, event_id)
         ## Check if there is a selected graph to remove
-        if self.graph.selected_plottable in self.plots.keys():
+        if self.graph.selected_plottable in self.plots:
             graph_id = self.graph.selected_plottable
             self.remove_data_by_id(graph_id)
@@ -603,5 +606,5 @@
             plot_menu = wx.Menu()
             if self.graph.selected_plottable:
-                if not self.graph.selected_plottable in self.plots.keys():
+                if not self.graph.selected_plottable in self.plots:
                     continue
                 if plot != self.plots[self.graph.selected_plottable]:
@@ -623,7 +626,7 @@
                         plot_menu.Append(wx_id, item[0], name)
                         wx.EVT_MENU(self, wx_id, item[2])
-                    except:
+                    except Exception as exc:
                         msg = "ModelPanel1D.onContextMenu: "
-                        msg += "bad menu item  %s" % sys.exc_value
+                        msg += "bad menu item  %s" % exc
                         wx.PostEvent(self.parent, StatusEvent(status=msg))
                 plot_menu.AppendSeparator()
